<template>
	<mind-view>
		<template v-slot:toolbar-actions>
			<el-button type="primary" size="small" @click="$refs.formulario?.onSubmit()" :disabled="!modificado" >Aplicar Cambios</el-button>
		</template>
		<mind-form  
			v-model="recurso"  v-model:modified="modificado"
			@submit="onSubmit" v-loading="isLoading"
			ref="formulario" 
			>
			<template v-slot="{form}">
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Apellido">
								<el-input v-model="form.apellido"/>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Nombre">
								<el-input v-model="form.nombre" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="DNI">
								<el-input  type="text" v-model="form.dni" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Activo">
								<el-checkbox  v-model="form.activo" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="Fecha Ingreso">
								<el-input clearable type="date"  v-model="form.fechaIngreso" />
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Fecha Egreso">
								<el-input type="date" v-model="form.fechaEgreso" :disabled="form.activo"/>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Vencimiento Registro">
								<el-input type="date" v-model="form.vencRegistro" />
							</el-form-item>
						</el-col>
					</el-row>

			</template>
		</mind-form>
	</mind-view>
</template>
<script>
import choferes from '@/model/choferes'

export default {
	async created(){
		this.isLoading = true;
		let id = this.$route.params.id;
		if (id == "new") {
			this.recurso = choferes.new()
		} else {
			this.recurso = await choferes.get(id)

		}
		this.isLoading = false;
	},
	computed: {
		esNuevo() {
			return this.recurso?._isNew
		}
		
	},

	methods: {
		async onSubmit(v) {
			delete(v.ultimaActualizacion)
			delete(v.estado)
			this.recurso = v
			const key = choferes.getKey()
			const esNuevo = this.esNuevo
			if(esNuevo) {
				this.recurso = await choferes.post(this.recurso)
				.then((response)=>{
					const id = response[0][key]
					this.$message({
						type: 'success',
						message: `Chofer creadao correctamente`,
					})
					//modifico la ruta
					const path = this.$router.currentRoute.path.replace(/\/new$/, `/${id}`)
					this.$router.replace(path)
				})
			} else {
				this.recurso = await choferes.patch(this.recurso)
				this.$message({
					type: 'success',
					message: "Chofer actualizado correctamente",
				})
			}

		},
	},
	data() {
		return {
			modificado: false,
			recurso: {},
		}
	}
}
</script>